#ifndef __ABSTRACT_ACTION_H__
#define __ABSTRACT_ACTION_H__

#include <ostream>


class AbstractAction
{
  public:
    /**
    * Konstruktor
    */
    AbstractAction();

    /**
    * Destruktor
    */
    virtual ~AbstractAction();

    /**
    * Outputmethode - zur Ausgabe von Informationen ueber die Action.
    * @param os - eine Referenz auf einen Outputstream
    */
    virtual void addInformation( std::ostream& os ) const;
};


inline std::ostream& operator<< ( std::ostream& os, const AbstractAction& a )
{
  a.addInformation( os );
  return os;
}

#endif
