#ifndef __LOG_H__
#define __LOG_H__

#include <iostream>

#ifdef __RL_LOGGING_ON__
  /**
  * \def LOGERROR
  * LOGERROR gibt einen errorstream aus
  */
  #define RL_LOGERROR( message ) \
    { \
      std::cerr << "ERROR: File: " << __FILE__ << "   " \
                << "Function: " << __FUNCTION__ << "   " \
                << "Line: " << __LINE__ << "   " \
                << " --> " << message << std::endl; \
    }

    #ifdef __RL_WARNING_ON__
      /**
      * \def LOGWARNING
      * LOGWARNING gibt einen errorstream aus
      */
      #define RL_LOGWARNING( message ) \
        { \
          std::cerr << "WARNING: File: " << __FILE__ << "   " \
                    << "Function: " << __FUNCTION__ << "   " \
                    << "Line: " << __LINE__ << "   " \
                    << " --> " << message << std::endl; \
        }
    #endif
    #ifndef __RL_WARNING_ON__
      #define RL_LOGWARNING( message )
    #endif

  /**
  * \def LOGDATA
  * LOGDATA gibt einen stdstream aus
  */
  #define RL_LOGDATA( message ) \
    { \
      std::cout << "File: " << __FILE__ << "   " \
                << "Function: " << __FUNCTION__ << "   " \
                << "Line: " << __LINE__ << "   " \
                << " --> " << message << std::endl; \
    }
#endif

#ifndef __RL_LOGGING_ON__
  #define RL_LOGERROR( message )
  #define RL_LOGWARNING( message )
  #define RL_LOGDATA( message )
#endif

#endif
