#ifndef __STATE_VALUE_FUNCTION_H__
#define __STATE_VALUE_FUNCTION_H__

#include "ValueFunction.h"
#include <string>

class State;


class StateValueFunction : public ValueFunction
{
  public:
    /**
    * Konstruktor
    * @param aStatePtr - Pointer auf den Zustand
    */
    StateValueFunction( State* aStatePtr );

    /**
    * Destruktor
    */
    virtual ~StateValueFunction();

    /**
    * Liefert den Wert fuer den aktuellen Zustand.
    * @return der Wert der Aktion
    */
    virtual const double getStateValue() const = 0;

    /**
    * Abspeichern
    * @param fileName - Name der Datei die geschrieben werden soll
    * @return 0 bei Erfolg, -1 bei Fehler
    */
    virtual const int save( const std::string& fileName ) const;

    /**
    * Laden
    * @param fileName - Name der Datei die geladen werden soll
    * @return 0 bei Erfolg, -1 bei Fehler
    */
    virtual const int load( const std::string& fileName );


  protected:
    /**
    * Abspeichern
    * @param file - Filehandle
    * @return 0 bei Erfolg, -1 bei Fehler
    */
    virtual const int save( FILE* file ) const = 0;

    /**
    * Laden
    * @param file - Filehandle
    * @return 0 bei Erfolg, -1 bei Fehler
    */
    virtual const int load( FILE* file ) = 0;
};

#endif
