#ifndef __TEMPORAL_DIFFERENCE_H__
#define __TEMPORAL_DIFFERENCE_H__

#include "RL++.h"

class StateValueFunction;


class TD : public RL_PP
{
  public:
    /**
    * Konstruktor
    * @param fileName - Filename der Konfigurationsdatei
    */
    TD( const std::string& fileName );

    /**
    * Der Destruktor
    */
    virtual ~TD();


  protected:
    /**
    * Initialisieren einer Episode
    */
    virtual void initEpisode();

    /**
    * Ein Zeitschritt der Episode.
    */
    virtual void step();

    /**
    * Ueberprueft ob die ValueFunctionPtr != 0 sind.
    * @return ValueFunctionPtr != 0
    */
    virtual const bool checkValueFunction() const;


    /** die Zustands-Wertfunktion */
    StateValueFunction* svfPtr;
};

#endif
