#ifndef __TYPES_H__
#define __TYPES_H__


namespace Types
{
  /**
  * CIRCLE - min und max der Variablen sind gleich --> Bsp. Winkel 0 == 360
  * CLIP - Ein Tiling ueberdeckt genau den Wertebereich
  *        --> durch die Verschiebung der Tilings ueberdeckt nur das erste den
  *            Wertebereich komplett
  * WRAP - Ein Tile mehr als beim CLIP, damit auch nach der Verschiebung der gesamte
  *        Wertebereich von allen Tilings abgedeckt wird.
  */
  enum TILE_TYPE
  {
    CIRCLE,
    CLIP,
    WRAP
  };

  /**
  * MAP - Traces werden in einer Map gehalten
  *       --> zum Index im Array wird der TraceValue gespeichert
  *       --> spart Platz und evtl. auch Zeit
  * ARRAY - Traces werden in einem Array gehalten
  *       --> Array hat die Groesse des Gewichtsarrays
  * Map sollt man verwenden wenn eine Episode wenig steps hat und in einem 
  * step nur wenige aktive Indizees vorkommen
  */
  enum TRACE_STORAGE
  {
    MAP,
    ARRAY
  };

  struct TILINGS_VAR_STRUCT
  {
    int id;
    double resolution;
    TILE_TYPE tileType;
  };
}

#endif
