#include "ValueFunction.h"
#include "State.h"

#include <cfloat>

// die static variablen initialisieren
double ValueFunction::value = 0.0;
double ValueFunction::minValue = -0.5;
double ValueFunction::maxValue = 0.5;


ValueFunction::ValueFunction( State* aStatePtr )
  : statePtr( aStatePtr )
{
  // den Funktionspointer initialisieren
  initWeightsFunctionPtr = &getValue;

  // minimales und maximales Gewicht sollten per default nicht begrenzt sein
  minWeightLimit = -1.0 * DBL_MAX;
  maxWeightLimit = DBL_MAX;

  // Soll eine Historie ueber die Zustaende einer Episode gehalten werden?
  // --> per default nein (Aufwand gering halten)
  episodeStateHistory = false;
}


ValueFunction::~ValueFunction()
{
  delete statePtr;
}
