#ifndef __VAR_VALUES_H__
#define __VAR_VALUES_H__

#include <string>

class VarValues
{
  public:
    /**
    * Konstruktor
    */
    VarValues( const std::string& varName );

    /**
    * Destruktor
    */
    virtual ~VarValues();

    /**
    * Abspeichern des Zustands
    * @param file - Filehandle
    * @return 0 bei Erfolg, -1 bei Fehler
    */
    virtual const int save( FILE* file ) const = 0;

    /**
    * Laden des Zustands
    * @param file - Filehandle
    * @return 0 bei Erfolg, -1 bei Fehler
    */
    virtual const int load( FILE* file ) = 0;


    /**
    * Liefert den Namen der Variablen.
    */
    inline const std::string& getName() const;

    /**
    * Setzt den Namen der Variablen.
    */
    inline void setName( const std::string& newName );


  protected:
    // der Name der Variablen
    std::string name;
};

inline const std::string& VarValues::getName() const
{
  return name;
}

inline void VarValues::setName( const std::string& newName )
{
  name = newName;
}

#endif
