#ifndef __WATKINS_H__
#define __WATKINS_H__

#include "RL++.h"

class ActionValueFunction;


class Watkins : public RL_PP
{
  public:
    /**
    * Konstruktor
    * @param fileName - Filename der Konfigurationsdatei
    */
    Watkins( const std::string& fileName );

    /**
    * Der Destruktor
    */
    virtual ~Watkins();


  protected:
    /**
    * Initialisieren einer Episode
    */
    virtual void initEpisode();

    /**
    * Ein Zeitschritt der Episode.
    */
    virtual void step();

    /**
    * Ueberprueft ob die ValueFunctionPtr != 0 sind.
    * @return ValueFunctionPtr != 0
    */
    virtual const bool checkValueFunction() const;


    /** die Action-Zustands-Wertfunktion */
    ActionValueFunction* avfPtr;
};

#endif
